//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

package com.seeyon.ctp.organization.manager;

import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.appLog.AppLogAction;
import com.seeyon.ctp.common.appLog.manager.AppLogManager;
import com.seeyon.ctp.common.authenticate.domain.User;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.i18n.ResourceUtil;
import com.seeyon.ctp.datasource.annotation.DataSourceName;
import com.seeyon.ctp.datasource.annotation.ProcessInDataSource;
import com.seeyon.ctp.organization.OrgConstants;
import com.seeyon.ctp.organization.OrgConstants.ORGENT_STATUS;
import com.seeyon.ctp.organization.OrgConstants.Role_NAME;
import com.seeyon.ctp.organization.bo.OrganizationMessage;
import com.seeyon.ctp.organization.bo.V3xOrgAccount;
import com.seeyon.ctp.organization.bo.V3xOrgLevel;
import com.seeyon.ctp.organization.dao.OrgCache;
import com.seeyon.ctp.organization.dao.OrgDao;
import com.seeyon.ctp.organization.dao.OrgHelper;
import com.seeyon.ctp.organization.po.OrgLevel;
import com.seeyon.ctp.organization.principal.PrincipalManager;
import com.seeyon.ctp.util.FlipInfo;
import com.seeyon.ctp.util.ParamUtil;
import com.seeyon.ctp.util.annotation.CheckRoleAccess;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

@ProcessInDataSource(
        name = DataSourceName.BASE
)
public class LevelManagerImpl implements LevelManager {
    private static final Log logger = LogFactory.getLog(LevelManagerImpl.class);
    protected OrgCache orgCache;
    protected OrgDao orgDao;
    protected OrgManagerDirect orgManagerDirect;
    protected OrgManager orgManager;
    protected PrincipalManager principalManager;
    protected AppLogManager appLogManager;

    public LevelManagerImpl() {
    }

    public void setOrgDao(OrgDao orgDao) {
        this.orgDao = orgDao;
    }

    public void setPrincipalManager(PrincipalManager principalManager) {
        this.principalManager = principalManager;
    }

    public void setOrgCache(OrgCache orgCache) {
        this.orgCache = orgCache;
    }

    public void setOrgManagerDirect(OrgManagerDirect orgManagerDirect) {
        this.orgManagerDirect = orgManagerDirect;
    }

    public void setOrgManager(OrgManager orgManager) {
        this.orgManager = orgManager;
    }

    public void setAppLogManager(AppLogManager appLogManager) {
        this.appLogManager = appLogManager;
    }

    @CheckRoleAccess(
            roleTypes = {Role_NAME.GroupAdmin, Role_NAME.AccountAdministrator, Role_NAME.HrAdmin,Role_NAME.SystemAdmin}
    )
    public Long saveLevel(String accountId, Map level) throws BusinessException {
        Long accId = Long.parseLong(accountId);
        User user = AppContext.getCurrentUser();
        V3xOrgLevel newlevel = new V3xOrgLevel();
        ParamUtil.mapToBean(level, newlevel, false);
        Integer groupLevelId = 100;
        if (null != newlevel.getGroupLevelId()) {
            groupLevelId = this.orgManager.getLevelById(newlevel.getGroupLevelId()).getLevelId();
        }

        boolean isMapRight = this.orgManager.isGroupLevelMapRight(accId, newlevel.getLevelId(), groupLevelId);
        if (!isMapRight) {
            V3xOrgLevel errorLevel = this.orgManager.getErrorMapLevel(accId, newlevel.getLevelId(), groupLevelId);
            if (errorLevel.getLevelId() > newlevel.getLevelId()) {
                throw new BusinessException(ResourceUtil.getString("level.map.group.low", errorLevel.getName()));
            } else {
                throw new BusinessException(ResourceUtil.getString("level.map.group.up", errorLevel.getName()));
            }
        } else {
            if (OrgConstants.GROUPID.equals(newlevel.getOrgAccountId())) {
                List<V3xOrgAccount> acclist = this.orgManager.getAllAccounts();
                Iterator var9 = acclist.iterator();

                while(var9.hasNext()) {
                    V3xOrgAccount v3xOrgAccount = (V3xOrgAccount)var9.next();
                    List<V3xOrgLevel> allLevels = this.orgManager.getAllLevels(v3xOrgAccount.getId());
                    Iterator var12 = allLevels.iterator();

                    while(var12.hasNext()) {
                        V3xOrgLevel v3xOrgLevel = (V3xOrgLevel)var12.next();
                        if (v3xOrgLevel.getGroupLevelId() != null && v3xOrgLevel.getGroupLevelId().equals(newlevel.getId())) {
                            boolean isGroupMapRight = this.orgManager.isGroupLevelMapRight(v3xOrgAccount.getId(), v3xOrgLevel.getLevelId(), newlevel.getLevelId());
                            if (!isGroupMapRight) {
                                V3xOrgLevel errorLevel = this.orgManager.getErrorMapLevel(v3xOrgAccount.getId(), v3xOrgLevel.getLevelId(), newlevel.getLevelId());
                                if (errorLevel.getLevelId() > newlevel.getLevelId()) {
                                    throw new BusinessException(ResourceUtil.getString("level.map.update.group.down", errorLevel.getName(), v3xOrgLevel.getName(), this.orgManager.getAccountById(v3xOrgLevel.getOrgAccountId()).getShortName()));
                                }

                                throw new BusinessException(ResourceUtil.getString("level.map.update.group.down", errorLevel.getName(), v3xOrgLevel.getName(), this.orgManager.getAccountById(v3xOrgLevel.getOrgAccountId()).getShortName()));
                            }
                        }
                    }
                }
            }

            OrganizationMessage m;
            if (newlevel.getId() == null) {
                newlevel.setIdIfNew();
                newlevel.setOrgAccountId(accId);
                m = this.orgManagerDirect.addLevel(newlevel);
                OrgHelper.throwBusinessExceptionTools(m);
                this.appLogManager.insertLog4Account(user, user.isGroupAdmin() ? accId : AppContext.currentAccountId(), AppLogAction.Organization_NewLevel, new String[]{user.getName(), newlevel.getName()});
            } else {
                m = this.orgManagerDirect.updateLevel(newlevel);
                OrgHelper.throwBusinessExceptionTools(m);
                this.appLogManager.insertLog4Account(user, user.isGroupAdmin() ? accId : AppContext.currentAccountId(), AppLogAction.Organization_UpdateLevel, new String[]{user.getName(), newlevel.getName()});
            }

            return newlevel.getId();
        }
    }

    @CheckRoleAccess(
            roleTypes = {Role_NAME.GroupAdmin, Role_NAME.AccountAdministrator, Role_NAME.HrAdmin,Role_NAME.SystemAdmin}
    )
    public String deleteLevel(List<Map<String, Object>> level) throws BusinessException {
        new ArrayList();
        List<V3xOrgLevel> levellist = ParamUtil.mapsToBeans(level, V3xOrgLevel.class, false);
        OrganizationMessage m = this.orgManagerDirect.deleteLevels(levellist);
        OrgHelper.throwBusinessExceptionTools(m);
        List<String[]> appLogs = new ArrayList();
        User user = AppContext.getCurrentUser();
        Iterator var6 = levellist.iterator();

        while(var6.hasNext()) {
            V3xOrgLevel l = (V3xOrgLevel)var6.next();
            String[] appLog = new String[]{user.getName(), l.getName()};
            appLogs.add(appLog);
        }

        this.appLogManager.insertLogs4Account(user, user.isGroupAdmin() ? ((V3xOrgLevel)levellist.get(0)).getOrgAccountId() : AppContext.currentAccountId(), AppLogAction.Organization_DeleteLevel, appLogs);
        return "";
    }

    @CheckRoleAccess(
            roleTypes = {Role_NAME.GroupAdmin, Role_NAME.AccountAdministrator, Role_NAME.HrAdmin,Role_NAME.SystemAdmin}
    )
    public HashMap viewLevel(Long levelId) throws BusinessException {
        HashMap map = new HashMap();
        ParamUtil.beanToMap(this.orgManager.getLevelById(levelId), map, false);
        if (!map.containsKey("groupLevelId")) {
            map.put("groupLevelId", (Object)null);
        }

        return map;
    }

    @CheckRoleAccess(
            roleTypes = {Role_NAME.GroupAdmin, Role_NAME.AccountAdministrator, Role_NAME.HrAdmin,Role_NAME.SystemAdmin}
    )
    public FlipInfo showLevelList(FlipInfo fi, Map params) throws BusinessException {
        Long accountId = Long.valueOf(params.get("accountId").toString());
        if (params.size() == 0) {
            this.orgDao.getAllLevelPO(accountId, (Boolean)null, (String)null, (Object)null, fi);
        } else {
            this.orgDao.getAllLevelPO(accountId, (Boolean)null, String.valueOf(params.get("condition")), params.get("value"), fi);
        }

        List list = fi.getData();
        List rellist = new ArrayList();

        HashMap m;
        for(Iterator var6 = list.iterator(); var6.hasNext(); rellist.add(m)) {
            Object object = var6.next();
            m = new HashMap();
            ParamUtil.beanToMap((OrgLevel)object, m, true);
            if (ORGENT_STATUS.DISABLED.ordinal() == Integer.parseInt(String.valueOf(m.get("status")))) {
                m.put("name", m.get("name") + "(" + ResourceUtil.getString("org.entity.disabled") + ")");
            }

            if (((OrgLevel)object).getGroupLevelId() != null && !((OrgLevel)object).getGroupLevelId().equals(0L)) {
                m.put("groupLevelId", this.orgManager.getLevelById(((OrgLevel)object).getGroupLevelId()).getLevelId());
            } else {
                m.put("groupLevelId", "");
            }
        }

        fi.setData(rellist);
        return fi;
    }
}
